#include<bits/stdc++.h>
using namespace std;
vector <int> v[1002];
string s[1002];
bool spojen[1002];
bool posecen[1002];
int dfs(int x, int y, int vrati)
{
    posecen[x]=true;
    for(auto a: v[x])
    {
        if(a==y)
            vrati++;
        else if(!posecen[a])
            vrati+=dfs(a,y);
    }
    return vrati;
}
int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n,q;
    cin>>n>>q;
    for(int i=0; i<q; i++)
    {
        int vrsta;
        cin>>vrsta;
        if(vrsta==1)
        {
            int x,y;
            char c;
            cin>>x>>y>>c;
            v[x].push_back(y);
            v[y].push_back(x);
        }
        else if(vrsta==2)
        {
            int x,y;
            cin>>x>>y;
            if(dfs(x,y,0)>0)
                    cout<<1<<'\n';
            else cout<<0<<'\n';
            for(int i=1; i<=n; i++)
                posecen[i]=false;
        }
    }
    return 0;
}